<?php

namespace App\Services;

use App\Services\common\QueryService;
use App\Waybill;
use Illuminate\Database\Eloquent\Builder;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;
use Ramsey\Uuid\Uuid;

Class WaybillService
{
    /**
     * @param array $param
     * @return Builder
     */
    private function conditionQuery(array $param){
        $waybills = Waybill::filterAuthorities()->with(['owner','carrier','originationCity','destinationCity'=>function($query){
            $query->with('province');
        },'uploadFile','amountUnit','priceModel','warehouseWeightUnit','carrierWeightUnit',
            'warehouseWeightUnitOther','carrierWeightUnitOther','carType','uploadFile','waybillAuditLogs' => function ($query) {
            $query->with('user');
        }])->selectRaw('waybills.* ,waybill_on_tops.id top_id ,waybill_on_tops.remark,waybill_on_tops.updated_at top_update')
            ->leftJoin('waybill_on_tops','waybill_on_tops.waybill_id','=','waybills.id')
            ->whereNull('waybill_on_tops.deleted_at')
            ->orderBy('waybill_on_tops.updated_at','desc')
            ->orderBy('waybills.id','desc');
        $columnQueryRules=[
            'waybill_number' => ['like' => ''],
            'carrier_bill' => ['like' => ''],
            'owner_id' => ['multi' => ','],
            'wms_bill_number' => ['like' => ''],
            'origination' => ['like' => ''],
            'destination' => ['like' => ''],
            'source_bill' => ['like' => ''],
            'created_at_start' => ['alias' => 'created_at' , 'startDate' => ':00'],
            'created_at_end' => ['alias' => 'created_at' , 'endDate' => ':59'],
            'uriType' => ['alias' => 'type'],
            'id' => ['multi' => ','],
        ];
        $waybills = app(QueryService::class)->query($param,$waybills,$columnQueryRules,"waybills");//dd($waybills->sql());
        return $waybills;
    }

    public function paginate(array $param){
        $waybills = $this->conditionQuery($param);
        return $waybills->paginate($param['paginate'] ?? 50);
    }

    public function get(array $param){
        $waybills = $this->conditionQuery($param);
        return $waybills->get();
    }

    public function getSql(array $param){
        $waybills = $this->conditionQuery($param)->whereNull('waybills.deleted_at');
        return $waybills->leftJoin('owners','owners.id','=','waybills.owner_id')->selectRaw('owners.name owner_name')
            ->leftJoin('units as warehouse_weight_unit','warehouse_weight_unit.id','=','waybills.warehouse_weight_unit_id')
                ->selectRaw('warehouse_weight_unit.name warehouse_weight_unit_name')
            ->leftJoin('units as warehouse_weight_unit_other','warehouse_weight_unit_other.id','=','waybills.warehouse_weight_unit_id_other')
                ->selectRaw('warehouse_weight_unit_other.name warehouse_weight_unit_other_name')
            ->leftJoin('units as carrier_weight_unit','carrier_weight_unit.id','=','waybills.carrier_weight_unit_id')
                ->selectRaw('carrier_weight_unit.name carrier_weight_unit_name')
            ->leftJoin('units as carrier_weight_unit_other','carrier_weight_unit_other.id','=','waybills.carrier_weight_unit_id_other')
                ->selectRaw('carrier_weight_unit_other.name carrier_weight_unit_other_name')
            ->leftJoin('car_types','car_types.id','=','waybills.carType_id')
                ->selectRaw('car_types.name car_type_name')
            ->leftJoin('units as amount_unit','amount_unit.id','=','waybills.amount_unit_id')
                ->selectRaw('amount_unit.name amount_unit_name')
            ->leftJoin('carriers','carriers.id','=','waybills.carrier_id')
                ->selectRaw('carriers.name carrier_name')
            ->sql();
    }

    public function store(Request $request){
        return DB::transaction(function ()use($request){
            $waybill=new Waybill();
            $inputs = $request->all();
            $inputs['status']='未审核';
            $inputs['waybill_number']=Uuid::uuid1();
            $waybill->fill($inputs);
            if ($request->collect_fee)$waybill->collect_fee=$request->collect_fee;
            $waybill->save();
            $number_id=$waybill->id;
            if ($request->type=='直发车') $waybill_number='BSZF';
            else $waybill_number='BSZX';
            $waybill_number .= date ("ymd").str_pad($number_id>99999?$number_id%99999:$number_id,4,"0",STR_PAD_LEFT);
            $waybill->update(['waybill_number' => $waybill_number ]);
            return $waybill;
        });
    }

    public function find($id){
        return Waybill::query()->find($id);
    }

    public function update(Request $request,$id)
    {
        $waybill = $this->find($id);
        //替换换行符
        if ($request->dispatch_remark) {
            $request->offsetSet('dispatch_remark', str_replace(["\n","\r"], ' ', $request->dispatch_remark));
        }
        if (!$request->destination) $request->offsetSet('destination', $waybill->destination);
        if ($request->destination_city_id && $waybill->destination_city_id != $request->destination_city_id) {
            $city = app(CityService::class)->find($request->destination_city_id);
            if ($city && $city->province_name && (mb_strpos($request->destination, $city->name) === false || mb_strpos($request->destination, $city->province_name) === false)) {
                if (mb_strpos($request->destination, $city->name) === false && mb_strpos($request->destination, $city->province_name) === false) {
                    $request->offsetSet('destination', $city->province_name . $city->name . $request->destination);
                    goto sign;
                }
                if (mb_strpos($request->destination, $city->province_name) === false) {
                    $request->offsetSet('destination', $city->province_name . $request->destination);
                }
                if (mb_strpos($request->destination, $city->name) === false) {
                    $province_name = $city->province_name;
                    $start_index = mb_strpos($request->destination, $city->province_name . '省');
                    if ($start_index === false) $start_index = mb_strpos($request->destination, $city->province_name);
                    else $province_name = $province_name . '省';
                    $strBefore = mb_substr($request->destination, $start_index, mb_strlen($province_name));
                    $strAfter = mb_substr($request->destination, $start_index + mb_strlen($province_name));
                    $request->offsetSet('destination', $strBefore . $city->name . $strAfter);
                }
            }
        }
        sign:
        $waybill->fill($request->input());
        $waybill->update();
        return $waybill;
    }

    public function getDeliveringSql(array $param){
        $waybills = $this->conditionQuery($param);
        if (!Auth::user()->isSuperAdmin()){
            $carriersUsers=DB::table('carrier_user')->where('user_id',Auth::id())->get();
            $carrierIds=array_column($carriersUsers->toArray(),'carrier_id');
            $waybills=$waybills->whereIn("waybills.carrier_id",$carrierIds);
        }
        return $waybills->leftJoin('owners','owners.id','=','waybills.owner_id')->selectRaw('owners.name owner_name')
            ->leftJoin('carriers','carriers.id','=','waybills.carrier_id')
            ->selectRaw('carriers.name carrier_name')
            ->sql();
    }
}
